VERSION 5.00
Begin VB.UserControl GifCtl 
   AutoRedraw      =   -1  'True
   ClientHeight    =   1215
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1425
   MaskColor       =   &H00000000&
   PropertyPages   =   "GifCtl.ctx":0000
   ScaleHeight     =   81
   ScaleMode       =   3  '
   ScaleWidth      =   95
   Begin VB.Timer tmrFrame 
      Left            =   480
      Top             =   360
   End
End
Attribute VB_Name = "GifCtl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Type BITMAPINFOHEADER
     biSize As Long
     biWidth As Long
     biHeight As Long
     biPlanes As Integer
     biBitCount As Integer
     biCompression As Long
     biSizeImage As Long
     biXPelsPerMeter As Long
     biYPelsPerMeter As Long
     biClrUsed As Long
     biClrImportant As Long
End Type
Private Declare Function SetDIBits Lib "gdi32" (ByVal hDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFOHEADER, ByVal wUsage As Long) As Long

Public Enum gcBackStyle
    gcTransparent = 0
    gcOpaque = 1
End Enum

Public Enum gcBorderStyle
    gcNone = 0
    gcFixedSingle = 1
End Enum

'Default Property Values:
Const m_def_AutoStart = True
Const m_def_AutoLoop = True
Const m_def_Enabled = True
'Property Variables:
Dim m_AutoStart As Boolean
Dim m_AutoLoop As Boolean
Dim m_Enabled As Boolean
'Event Declarations:
Event Click() 'MappingInfo=UserControl,UserControl,-1,Click
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick() 'MappingInfo=UserControl,UserControl,-1,DblClick
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyDown
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Event KeyPress(KeyAscii As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyPress
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Event KeyUp(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyUp
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseUp
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."
Event FrameChanged()
Event AnimationDone()
Event ResizeMe(ByVal w As Long, ByVal h As Long)

Private Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
  (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Dim GIF As clsGIF, DoneInit As Boolean

Dim m_fly As Boolean
Public hwndParent As Long

Dim Frames As Collection 'of clsFrame
Dim CurrentFrame As Long, Frame As clsFrame

Public Property Get fly() As Boolean
   fly = m_fly
   
End Property

Public Property Let fly(ByVal New_fl As Boolean)
m_fly = New_fl
If m_fly Then
    SetParent hWnd, 0
    SetWindowPos hWnd, -1, 0, 0, 0, 0, &H2 Or &H1
    SetWindowLong hWnd, -8, Parent.hWnd
    
Else
    SetParent hWnd, hwndParent
    
End If

End Property



'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor = New_BackColor
    PropertyChanged "BackColor"
    If Not (Frame Is Nothing) Then ApplyPicture
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackStyle
Public Property Get BackStyle() As gcBackStyle
    BackStyle = UserControl.BackStyle
End Property

Public Property Let BackStyle(ByVal New_BackStyle As gcBackStyle)
    UserControl.BackStyle = New_BackStyle
    PropertyChanged "BackStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As gcBorderStyle
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As gcBorderStyle)
    UserControl.BorderStyle = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent MouseDown(Button, Shift, x, y)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent MouseMove(Button, Shift, x, y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent MouseUp(Button, Shift, x, y)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,hWnd
Public Property Get hWnd() As Long
    hWnd = UserControl.hWnd
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Image
Public Property Get Image() As StdPicture
Attribute Image.VB_Description = "Returns/sets a graphic to be displayed in a control."
    Set Image = UserControl.Image
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,True
Public Property Get AutoStart() As Boolean
    AutoStart = m_AutoStart
End Property

Public Property Let AutoStart(ByVal New_AutoStart As Boolean)
    m_AutoStart = New_AutoStart
    PropertyChanged "AutoStart"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,True
Public Property Get AutoLoop() As Boolean
    AutoLoop = m_AutoLoop
End Property

Public Property Let AutoLoop(ByVal New_AutoLoop As Boolean)
    m_AutoLoop = New_AutoLoop
    PropertyChanged "AutoLoop"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,1,0,
Public Sub LoadFile(ByVal Filename As String)
    PropertyChanged "File"
    Set GIF = New clsGIF
    GIF.LoadFile Filename
    
    DoneInit = False
    LoadInternal
    
    RaiseEvent ResizeMe(GIF.Width, GIF.Height)
End Sub

Private Sub LoadInternal()
Dim NextFrame As StdPicture, NewFrame As clsFrame
    Set Frames = New Collection
    CurrentFrame = 0
    
    GIF.Reset
'    Do
'        Set NextFrame = GIF.NextFrame
'        If NextFrame Is Nothing Then Exit Do
'
'        Set NewFrame = New clsFrame
'        Set NewFrame.Bitmap = NextFrame
'        Set NewFrame.Mask = GIF.NextMask
'        NewFrame.DelayMS = GIF.DelayMS
'        Frames.Add NewFrame
'    Loop
    Set NewFrame = New clsFrame
    NewFrame.LoadNext GIF
    If NewFrame.Bitmap Is Nothing Then Exit Sub
    Frames.Add NewFrame
    
    UserControl_Show
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=tmrFrame,tmrFrame,-1,Enabled
Public Property Get Enabled() As Boolean
    Enabled = m_Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    If m_Enabled = New_Enabled Then Exit Property
    m_Enabled = New_Enabled
    If Ambient.UserMode Then
        If New_Enabled Then tmrFrame_Timer Else tmrFrame.Enabled = False
    End If
    PropertyChanged "Enabled"
End Property


'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_AutoStart = m_def_AutoStart
    m_AutoLoop = m_def_AutoLoop
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    UserControl.BackStyle = PropBag.ReadProperty("BackStyle", 1)
    UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
    m_AutoStart = PropBag.ReadProperty("AutoStart", m_def_AutoStart)
    m_AutoLoop = PropBag.ReadProperty("AutoLoop", m_def_AutoLoop)
    m_Enabled = PropBag.ReadProperty("Enabled", m_def_Enabled)
On Error GoTo SkipLoad
    Dim data() As Byte
    data = PropBag.ReadProperty("File")
    Set GIF = New clsGIF
    GIF.GIFdata = data
    LoadInternal
SkipLoad:
End Sub

Private Sub UserControl_Resize()
    If Not (Frame Is Nothing) Then ApplyPicture
End Sub

Private Sub UserControl_Show()
    If DoneInit Then Exit Sub
    tmrFrame_Timer
    If Ambient.UserMode Then
        m_Enabled = m_AutoStart 'Or m_Enabled
        tmrFrame.Enabled = m_Enabled
    Else
        tmrFrame.Enabled = False
    End If
    DoneInit = True
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("BackStyle", UserControl.BackStyle, 1)
    Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 0)
    Call PropBag.WriteProperty("AutoStart", m_AutoStart, m_def_AutoStart)
    Call PropBag.WriteProperty("AutoLoop", m_AutoLoop, m_def_AutoLoop)
    If Not (GIF Is Nothing) Then
        Call PropBag.WriteProperty("File", GIF.GIFdata)
    End If
    Call PropBag.WriteProperty("Enabled", m_Enabled, m_def_Enabled)
End Sub

Private Sub tmrFrame_Timer()
    tmrFrame.Enabled = False
    If Frames Is Nothing Then Exit Sub
    If Frames.Count = 0 Then Exit Sub
    CurrentFrame = CurrentFrame + 1
    If CurrentFrame > Frames.Count Then
        'lazyly load a frame
        Set Frame = New clsFrame
        Frame.LoadNext GIF
        If Frame.Bitmap Is Nothing Then
            CurrentFrame = 1
            RaiseEvent AnimationDone
            If Not m_AutoLoop Then Exit Sub
            Set Frame = Frames(CurrentFrame)
        Else
            Frames.Add Frame
        End If
    Else
        Set Frame = Frames(CurrentFrame)
    End If
    
    ApplyPicture
    RaiseEvent FrameChanged
    tmrFrame.Interval = Frame.DelayMS
    If Frame.DelayMS Then
        tmrFrame.Enabled = True
    ElseIf Frames.Count > 1 Then
        tmrFrame_Timer
    End If
End Sub

Private Sub ApplyPicture()
If Frame.Bitmap Is Nothing Then Exit Sub
    'too many troubles, as caused by absence of MaskBlt in Win9x
Dim hDC As Long, hBmp As Long, hBmpOld As Long, w As Long, h As Long
Dim hDCSource As Long, hOldBMSrc As Long, hBMMask As Long
Dim bih As BITMAPINFOHEADER, bits() As Long, hUCDC As Long
    w = UserControl.ScaleWidth: h = UserControl.ScaleHeight
    With bih
        .biSize = Len(bih)
        .biWidth = w
        .biHeight = h
        .biPlanes = 1
        .biBitCount = 32
        .biSizeImage = 4& * w * h
    End With
    ReDim bits(w * h - 1)
    UserControl.Cls
    hUCDC = UserControl.hDC
    hDC = CreateCompatibleDC(hUCDC)
    hBmp = CreateCompatibleBitmap(hUCDC, w, h)
    SetDIBits hUCDC, hBmp, 0, h, bits(0), bih, 0 'newly created bitmaps aren't blank under Win9x
    hBmpOld = SelectObject(hDC, hBmp)
    hDCSource = CreateCompatibleDC(hUCDC)
    hOldBMSrc = SelectObject(hDCSource, Frame.Bitmap)
    BitBlt hDC, 0, 0, w, h, hDCSource, 0, 0, vbSrcCopy
    SelectObject hDCSource, Frame.Mask
    BitBlt hDC, 0, 0, w, h, hDCSource, 0, 0, vbSrcAnd
    hBMMask = CreateCompatibleBitmap(hUCDC, w, h)
    SetDIBits hUCDC, hBMMask, 0, h, bits(0), bih, 0 'newly created bitmaps aren't blank under Win9x
    SelectObject hDC, hBMMask
    BitBlt hDC, 0, 0, w, h, 0, 0, 0, vbDstInvert
    BitBlt hDC, 0, 0, w, h, hDCSource, 0, 0, vbNotSrcCopy
    BitBlt hUCDC, 0, 0, w, h, hDC, 0, 0, vbSrcAnd
    DeleteObject SelectObject(hDC, hBmp)
    BitBlt hUCDC, 0, 0, w, h, hDC, 0, 0, vbSrcPaint
    SelectObject hDCSource, hOldBMSrc
    DeleteDC hDCSource
    DeleteObject SelectObject(hDC, hBmpOld)
    DeleteDC hDC
    Set UserControl.MaskPicture = Frame.Mask
End Sub
